## krb5 1.12+dfsg

=== debian/changelog ===
krb5 (1.12+dfsg-2ubuntu5.4) trusty-security; urgency=medium

  * SECURITY UPDATE: DoS (out-of-bounds read) via a crafted string
    - debian/patches/CVE-2015-8629.patch: Verify decode kadmin C strings
    - CVE-2015-8629
  * SECURITY UPDATE: DoS (NULL pointer dereference) by specifying KADM5_POLICY
    with a NULL policy name
    - debian/patches/CVE-2015-8630.patch: Check for null kadm5 policy name
    - CVE-2015-8630
  * SECURITY UPDATE: DoS (memory consumption) via a request specifying a NULL
    principal name
    - debian/patches/CVE-2015-8631.patch: Fix leaks in kadmin server stubs
    - CVE-2015-8631
  * SECURITY UPDATE: DoS (NULL pointer dereference) via a crafted request to
    modify a principal
    - debian/patches/CVE-2016-3119.patch: Fix LDAP null dereference on
      empty arg
    - CVE-2016-3119
  * SECURITY UPDATE: DoS (NULL pointer dereference) via an S4U2Self request
    - debian/patches/CVE-2016-3120.patch: Fix S4U2Self KDC crash when anon
      is restricted
    - CVE-2016-3120
  * SECURITY UPDATE: KDC assertion failure
    - debian/patches/CVE-2017-11368-1.patch: Prevent KDC unset status
      assertion failures
    - debian/patches/CVE-2017-11368-2.patch: Simplify KDC status assignment
    - CVE-2017-11368
  * SECURITY UPDATE: Double free vulnerability
    - debian/patches/CVE-2017-11462.patch: Preserve GSS context on init/accept
      failure
    - CVE-2017-11462
  * SECURITY UPDATE: Authenticated kadmin with permission to add principals
    to an LDAP Kerberos can DoS or bypass DN container check.
    - debian/patches/CVE-2018-5729-CVE-2018-5730.patch: Fix flaws in LDAP DN
      checking
    - CVE-2018-5729
    - CVE-2018-5730

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Wed, 09 Jan 2019 14:01:22 -0200

krb5 (1.12+dfsg-2ubuntu5.3) trusty; urgency=medium

  * d/p/upstream/0001-Add-SPNEGO-special-case-for-NTLMSSP-MechListMIC.patch:
    Cherry-pick from upstream to add SPNEGO special case for
    NTLMSSP+MechListMIC.  LP: #1643708.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 21 Nov 2016 18:14:47 -0800

=== debian/control ===
Source: krb5
Section: net
Priority: standard
Build-Depends: debhelper (>= 8.1.3), byacc | bison,
 comerr-dev, docbook-to-man, doxygen,
 libkeyutils-dev [linux-any], libldap2-dev,
 libncurses5-dev, libssl-dev,  ss-dev, 
 libverto-dev (>= 0.2.4), pkg-config
build-depends-indep: python-cheetah, python-lxml, python-sphinx, doxygen-latex
Standards-Version: 3.9.5
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Sam Hartman <hartmans@debian.org>
Uploaders: Russ Allbery <rra@debian.org>, Benjamin Kaduk <kaduk@mit.edu>
Homepage: http://web.mit.edu/kerberos/
VCS-Git: git://git.debian.org/git/pkg-k5-afs/debian-krb5-2013.git
VCS-Browser: http://git.debian.org/?p=pkg-k5-afs/debian-krb5-2013.git

Package: krb5-user
Architecture: any
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
  krb5-config
Conflicts: heimdal-clients
Description: Basic programs to authenticate using MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the basic programs to authenticate to MIT Kerberos,
 change passwords, and talk to the admin server (to create and delete
 principals, list principals, etc.).

Package: krb5-kdc
Architecture: any
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
 libkadm5srv-mit9,
 krb5-config, krb5-user, lsb-base (>= 3.0-6), libverto-libev1 | libverto-libevent1
Suggests: openbsd-inetd | inet-superserver, krb5-admin-server,
 krb5-kdc-ldap (= ${binary:Version})
Description: MIT Kerberos key server (KDC)
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the Kerberos key server (KDC).  The KDC manages all
 authentication credentials for a Kerberos realm, holds the master keys
 for the realm, and responds to authentication requests.  This package
 should be installed on both master and slave KDCs.

Package: krb5-kdc-ldap
Architecture: any
Priority: extra
Depends: ${misc:Depends}, ${shlibs:Depends}, krb5-kdc (= ${binary:Version})
Description: MIT Kerberos key server (KDC) LDAP plugin
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the LDAP plugin for the Kerberos key server (KDC)
 and supporting utilities.  This plugin allows the KDC data to be stored
 in an LDAP server rather than the default local database.  It should be
 installed on both master and slave KDCs that use LDAP as a storage
 backend.

Package: krb5-admin-server
Architecture: any
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
 krb5-kdc (>= 1.10+dfsg~), lsb-base (>= 3.0-6)
Description: MIT Kerberos master server (kadmind)
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the Kerberos master server (kadmind), which handles
 account creations and deletions, password changes, and other
 administrative commands via the Kerberos admin protocol.  It also
 contains the command used by the master KDC to propagate its database to
 slave KDCs.  This package is generally only used on the master KDC for a
 Kerberos realm.

Package: krb5-multidev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libkrb5-3 (= ${binary:Version}),
 libk5crypto3 (= ${binary:Version}), libgssapi-krb5-2 (= ${binary:Version}),
 libgssrpc4 (= ${binary:Version}),
 libkadm5srv-mit9  (= ${binary:Version}),
 libkadm5clnt-mit9 (= ${binary:Version}),
 comerr-dev, 
Priority: optional
Suggests: krb5-doc
Description: Development files for MIT Kerberos without Heimdal conflict
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 Most users wishing to build applications against MIT Kerberos should
 install libkrb5-dev.  However, that package conflicts with heimdal-dev.
 This package installs libraries and headers in /usr/include/mit-krb5 and
 /usr/lib/mit-krb5 and can be installed along side heimdal-multidev, which
 provides the same facilities for Heimdal.

Package: libkrb5-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, krb5-multidev (= ${binary:Version})
Replaces: krb5-multidev (<< 1.8+dfsg~alpha1-3)
Conflicts: heimdal-dev
Priority: extra
Suggests: krb5-doc
Description: Headers and development libraries for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the symlinks, headers, and development libraries
 needed to compile and link programs that use the Kerberos libraries.

Package: libkrb5-dbg
Architecture: any
Depends: ${misc:Depends}, libkrb5-3 (= ${binary:Version})
 | libk5crypto3 (= ${binary:Version})
 | libkrb5support0 (= ${binary:Version})
Priority: extra
Section: debug
Multi-Arch: same
Description: Debugging files for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the debugging information for the MIT Kerberos
 libraries.  Install this package if you need to trace problems inside the
 MIT Kerberos libraries with a debugger.

Package: krb5-pkinit
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version})
Suggests: opensc
Priority: extra
Multi-Arch: same
Description: PKINIT plugin for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains a plugin for the PKINIT protocol, which allows
 Kerberos tickets to be obtained using public-key credentials such as
 X.509 certificates or a smart card.  This plugin can be used by the
 client libraries and the KDC.  

Package: krb5-otp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrad0 (= ${binary:Version})
Priority: extra
Multi-Arch: same
Description: OTP plugin for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains a plugin for the OTP preauthentication method
 (RFC 6560), which allows Kerberos tickets to be obtained using
 One-Time Password authentication.  This plugin is for use on the KDC; the
 client support is built in to libkrb5.

Package: krb5-doc
Architecture: all
Priority: optional
Conflicts: heimdal-docs
Section: doc
Depends: ${misc:Depends}
Description: Documentation for MIT Kerberos
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the installation, administrator, and user reference
 manuals for MIT Kerberos and the man pages for the MIT Kerberos
 configuration files.

Package: libkrb5-3
Section: libs
Breaks:  sssd (<= 1.2.1-4.3), libsmbclient (<= 2:3.6.1-2)
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
 libkrb5support0 (= ${binary:Version})
Suggests: krb5-doc, krb5-user
Conflicts: libkrb53
Recommends: krb5-locales
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: MIT Kerberos runtime libraries
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the runtime library for the main Kerberos v5 API
 used by applications and Kerberos clients.

Package: libgssapi-krb5-2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version})
Suggests: krb5-doc, krb5-user
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Breaks: libgssglue1 (<< 0.2-2)
Description: MIT Kerberos runtime libraries - krb5 GSS-API Mechanism
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains the runtime library for the MIT Kerberos
 implementation of GSS-API used by applications and Kerberos clients.

Package: libgssrpc4
Section: libs
Conflicts: libkadm55
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: krb5-doc, krb5-user
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: MIT Kerberos runtime libraries - GSS enabled ONCRPC
 Kerberos is a system for authenticating users and services on a network.
 Kerberos is a trusted third-party service.  That means that there is a
 third party (the Kerberos server) that is trusted by all the entities on
 the network (users and services, usually called "principals").
 .
 This is the MIT reference implementation of Kerberos V5.
 .
 This package contains an RPC library used by the Kerberos administrative
 programs and potentially other applications.

Package: libkadm5srv-mit9
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: krb5-doc, krb5-user
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: MIT Kerberos runtime libraries - KDC and Admin Server
 Kerberos is a system for authenticating users and services on a network.

## krb5 1.12.1+dfsg

=== debian/changelog ===
krb5 (1.12.1+dfsg-19+deb8u4) jessie; urgency=medium

  * New version number; same code as deb8u3 but rebuilt to build arch all
    packages and because dgit doesn't deal well with reusing a version
    number when a package is rejected

 -- Sam Hartman <hartmans@debian.org>  Mon, 28 Aug 2017 11:55:49 -0400

krb5 (1.12.1+dfsg-19+deb8u3) jessie; urgency=high

  * CVE-2017-11368: Remote authenticated attackers can crash the KDC,
    Closes: #869260
  *  fix for CVE-2016-3120 (kdc crash on restrict_anon_to_tgt), Closes:
    #832572
  * fix for CVE-2016-3119: remote DOS with ldap for authenticated
    attackers, Closes: #819468
  * Prevent requires_preauth bypass (CVE-2015-2694), Closes: #783557
  
 -- Sam Hartman <hartmans@debian.org>  Sun, 13 Aug 2017 18:02:34 -0400

krb5 (1.12.1+dfsg-19+deb8u2) jessie-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Verify decoded kadmin C strings [CVE-2015-8629]
    CVE-2015-8629: An authenticated attacker can cause kadmind to read
    beyond the end of allocated memory by sending a string without a
    terminating zero byte. Information leakage may be possible for an
    attacker with permission to modify the database. (Closes: #813296)
  * Check for null kadm5 policy name [CVE-2015-8630]
    CVE-2015-8630: An authenticated attacker with permission to modify a
    principal entry can cause kadmind to dereference a null pointer by
    supplying a null policy value but including KADM5_POLICY in the mask.
    (Closes: #813127)
  * Fix leaks in kadmin server stubs [CVE-2015-8631]
    CVE-2015-8631: An authenticated attacker can cause kadmind to leak
    memory by supplying a null principal name in a request which uses one.
    Repeating these requests will eventually cause kadmind to exhaust all
    available memory. (Closes: #813126)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 31 Jan 2016 11:48:01 +0100

krb5 (1.12.1+dfsg-19+deb8u1) jessie-security; urgency=high

  * Import upstream patches for four CVEs:
    - CVE-2015-2695: SPNEGO context aliasing during establishment,
      Closes: #803083
    - CVE-2015-2696: IAKERB context aliasing during establishment,
      Closes: #803084
    - CVE-2015-2697: unsafe string handling in TGS processing,
      Closes: #803088
    - CVE-2015-2698: regression (memory corruption) in patch for CVE-2015-2696
  * In addition to CVE-2015-2698, the upstream patches for CVE-2015-2695
    and CVE-2015-2696 introduced regressions preventing the use of
    gss_import_sec_context() with contexts established using IAKERB
    or SPNEGO; the fixes for those regressions are included here.

 -- Benjamin Kaduk <kaduk@mit.edu>  Wed, 04 Nov 2015 22:05:10 -0500

krb5 (1.12.1+dfsg-19) unstable; urgency=medium

  * mark systemd unit directories as optional, Closes: #780831

 -- Sam Hartman <hartmans@debian.org>  Fri, 20 Mar 2015 16:22:33 -0400

krb5 (1.12.1+dfsg-18) unstable; urgency=high

  * Import upstream patch for CVE-2014-5355, Closes: #778647

 -- Benjamin Kaduk <kaduk@mit.edu>  Wed, 18 Feb 2015 12:52:14 -0500

krb5 (1.12.1+dfsg-17) unstable; urgency=high

  * MITKRB5-SA-2015-001
    - CVE-2014-5352: gss_process_context_token() incorrectly frees context
    - CVE-2014-9421: kadmind doubly frees partial deserialization results
    - CVE-2014-9422: kadmind incorrectly validates server principal name  
      - CVE-2014-9423: libgssrpc server applications leak uninitialized bytes


 -- Sam Hartman <hartmans@debian.org>  Tue, 03 Feb 2015 10:29:35 -0500

krb5 (1.12.1+dfsg-16) unstable; urgency=medium

  * Import upstream patches for CVE-2014-5353 and CVE-2014-5354,
    Closes: #773226, Closes: #773228

 -- Benjamin Kaduk <kaduk@mit.edu>  Mon, 15 Dec 2014 16:18:26 -0500

krb5 (1.12.1+dfsg-15) unstable; urgency=medium

  * Also apply slapd-before-kdc.conf to krb5-admin-server.service.d,
    Closes: #769710

 -- Benjamin Kaduk <kaduk@mit.edu>  Fri, 21 Nov 2014 12:36:08 -0500

krb5 (1.12.1+dfsg-14) unstable; urgency=medium

  * The upstream patch in 1.12.1+dfsg-13 was incomplete; pull in
    another upstream patch upon which it depended, to fix the
    kfreebsd build, Closes: #768379

 -- Benjamin Kaduk <kaduk@mit.edu>  Fri, 07 Nov 2014 13:17:36 -0500

krb5 (1.12.1+dfsg-13) unstable; urgency=medium

  * Remove the ExecReload line added in 1.12.1+dfsg-12; it is not
    a regression from the SysV init script and therefore not suitable
    for jessie post-freeze
  * Apply upstream patch to fix build on FreeBSD 10.1, Closes: #768379

 -- Benjamin Kaduk <kaduk@mit.edu>  Thu, 06 Nov 2014 18:08:26 -0500

krb5 (1.12.1+dfsg-12) unstable; urgency=medium

  * Fix typo in krb5-kdc EnvironmentFile name, Closes: #768344
  * Add an ExecReload line to krb5-kdc.service to help with log rotation

 -- Benjamin Kaduk <kaduk@mit.edu>  Thu, 06 Nov 2014 15:30:44 -0500

krb5 (1.12.1+dfsg-11) unstable; urgency=medium

  * Provide systemd service units for krb5-kdc, Partially affects: #734161
  * Provide systemd overrides to start  slapd first when krb5-kdc-ldap is
    installed, Thanks Michael Biebl, Closes: #758992
  * Provide kadmind service unit, Closes: #734161
  * Drop support for RUN_KADMIND in favor of update-rc.d disable
  * In krb5_newrealm, use service rather than calling init scripts directly

 -- Sam Hartman <hartmans@debian.org>  Mon, 20 Oct 2014 16:51:09 -0400

krb5 (1.12.1+dfsg-10) unstable; urgency=medium

  * Import upstream's patch for CVE-2014-5351, Closes: #762479

 -- Benjamin Kaduk <kaduk@mit.edu>  Mon, 22 Sep 2014 14:53:33 -0400

krb5 (1.12.1+dfsg-9) unstable; urgency=high

  [ Jelmer Vernooij ]
  * Reintroduce changes to move krb5-config into krb5-multidev:
   + Provide -L and -I flags from krb5-config. Closes: #730837
   + Ship krb5-config.mit binary in krb5-multidev., Closes: #745322
   + Provide -L and -I flags from pkg-config files. Closes: #750041
  * Use -isystem for include paths, to prevent the compiler from warning
    about problems in them. Closes: #751760

  [ Sam Hartman ]


=== debian/control ===
--- 
+++ 
@@ -5,11 +5,10 @@
  comerr-dev, docbook-to-man, doxygen,
  libkeyutils-dev [linux-any], libldap2-dev,
  libncurses5-dev, libssl-dev,  ss-dev, 
- libverto-dev (>= 0.2.4), pkg-config
+ libverto-dev (>= 0.2.4), pkg-config, dh-systemd
 build-depends-indep: python-cheetah, python-lxml, python-sphinx, doxygen-latex
 Standards-Version: 3.9.5
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sam Hartman <hartmans@debian.org>
+Maintainer: Sam Hartman <hartmans@debian.org>
 Uploaders: Russ Allbery <rra@debian.org>, Benjamin Kaduk <kaduk@mit.edu>
 Homepage: http://web.mit.edu/kerberos/
 VCS-Git: git://git.debian.org/git/pkg-k5-afs/debian-krb5-2013.git
@@ -280,3 +279,4 @@
 Pre-Depends: ${misc:Pre-Depends}
 Description: MIT Kerberos runtime libraries - KDC and Admin Server
  Kerberos is a system for authenticating users and services on a network.
+ Kerberos is a trusted third-party service.  That means that there is a

## krb5 1.13.2+dfsg

=== doc/api/Makefile ===
.SUFFIXES: .tex .dvi .ps

SHELL=/bin/sh

STYLES= fixunder.sty functions.sty krb5idx.sty
LIBTEX= library.tex intro.tex tables.tex errors.tex krb5.tex ccache.tex \
	rcache.tex keytab.tex libos.tex free.tex

DESTEX= libdes.tex

all: library.ps libdes.ps


libdes.dvi: $(DESTEX) $(STYLES)

library.ps: library.dvi

clean:
	rm -f *.toc *.log *.idx *.ind *.aux *.ilg lib1.stamp

really-clean: clean
	rm -f *.dvi *.ps


library.dvi:  lib1.stamp $(LIBTEX) $(STYLES)
	latex library

lib1.stamp: $(LIBTEX) $(STYLES)
	touch library.ind
	latex library
	makeindex -s krb5.ist library.idx
	date > lib1.stamp

.tex.dvi:
	latex $*


.dvi.ps:
	dvips $*.dvi -o

=== debian/changelog ===
krb5 (1.13.2+dfsg-5ubuntu2.2) xenial-security; urgency=medium

  * SECURITY UPDATE: Unbounded recursion
    - debian/patches/CVE-2020-28196.patch: adds recursion limit for ASN.1
      indefinite lenghts in src/lib/krb5/asn.1/asn1_encode.c.
    - CVE-2020-28196

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Wed, 11 Nov 2020 11:24:12 -0300

krb5 (1.13.2+dfsg-5ubuntu2.1) xenial-security; urgency=medium

  * SECURITY UPDATE: DoS (NULL pointer dereference) via a crafted request to
    modify a principal
    - debian/patches/CVE-2016-3119.patch: Fix LDAP null dereference on
      empty arg
    - CVE-2016-3119
  * SECURITY UPDATE: DoS (NULL pointer dereference) via an S4U2Self request
    - debian/patches/CVE-2016-3120.patch: Fix S4U2Self KDC crash when anon
      is restricted
    - CVE-2016-3120
  * SECURITY UPDATE: KDC assertion failure
    - debian/patches/CVE-2017-11368-1.patch: Prevent KDC unset status
      assertion failures
    - debian/patches/CVE-2017-11368-2.patch: Simplify KDC status assignment
    - CVE-2017-11368
  * SECURITY UPDATE: Double free vulnerability
    - debian/patches/CVE-2017-11462.patch: Preserve GSS context on init/accept
      failure
    - CVE-2017-11462
  * SECURITY UPDATE: Authenticated kadmin with permission to add principals
    to an LDAP Kerberos can DoS or bypass DN container check.
    - debian/patches/CVE-2018-5729-CVE-2018-5730.patch: Fix flaws in LDAP DN
      checking
    - CVE-2018-5729
    - CVE-2018-5730 

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Fri, 11 Jan 2019 13:46:00 -0200

krb5 (1.13.2+dfsg-5ubuntu2) xenial; urgency=medium

  * Fix segfault in context_handle (LP: #1648901).
    - d/p/check_internal_context_on_init_context_errors.patch: 
    Cherry picked patch from upstream VCS.

 -- Eric Desrochers <eric.desrochers@canonical.com>  Mon, 16 Jan 2017 15:06:57 +0100

krb5 (1.13.2+dfsg-5ubuntu1) xenial; urgency=medium

  * d/p/upstream/0001-Add-SPNEGO-special-case-for-NTLMSSP-MechListMIC.patch:
    Cherry-pick from upstream to add SPNEGO special case for
    NTLMSSP+MechListMIC.  LP: #1643708.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 21 Nov 2016 17:28:15 -0800

krb5 (1.13.2+dfsg-5) unstable; urgency=high

  *  Security Update
  * Verify decoded kadmin C strings [CVE-2015-8629]
    CVE-2015-8629: An authenticated attacker can cause kadmind to read
    beyond the end of allocated memory by sending a string without a
    terminating zero byte. Information leakage may be possible for an
    attacker with permission to modify the database. (Closes: #813296)
  * Check for null kadm5 policy name [CVE-2015-8630]
    CVE-2015-8630: An authenticated attacker with permission to modify a
    principal entry can cause kadmind to dereference a null pointer by
    supplying a null policy value but including KADM5_POLICY in the mask.
    (Closes: #813127)
  * Fix leaks in kadmin server stubs [CVE-2015-8631]
    CVE-2015-8631: An authenticated attacker can cause kadmind to leak
    memory by supplying a null principal name in a request which uses one.
    Repeating these requests will eventually cause kadmind to exhaust all
    available memory. (Closes: #813126)


 -- Sam Hartman <hartmans@debian.org>  Tue, 23 Feb 2016 08:54:09 -0500

krb5 (1.13.2+dfsg-4) unstable; urgency=high

  * Import upstream patches fixing regressions in the previous upload:
    - CVE-2015-2698: the patch for CVE-2015-2696 caused memory corruption
      for applications calling gss_export_sec_context() on contexts
      established using the IAKERB mechanism.
    - Supply gss_import_sec_context implementations for SPNEGO and IAKERB,
      which were not implemented due to the erroneous belief that the
      exported context tokens would be tagged with the underlying
      context's mechanism.

 -- Benjamin Kaduk <kaduk@mit.edu>  Wed, 04 Nov 2015 22:47:22 -0500

krb5 (1.13.2+dfsg-3) unstable; urgency=high

  * Import upstream patches for three CVEs:
    - CVE-2015-2695: SPNEGO context aliasing during establishment
    - CVE-2015-2696: IAKERB context aliasing during establishment
    - CVE-2015-2697: unsafe string handling in TGS processing

 -- Benjamin Kaduk <kaduk@mit.edu>  Mon, 26 Oct 2015 14:03:52 -0400

krb5 (1.13.2+dfsg-2) unstable; urgency=medium

  * No-change rebuild to target unstable

 -- Benjamin Kaduk <kaduk@mit.edu>  Thu, 25 Jun 2015 17:10:03 -0400

krb5 (1.13.2+dfsg-1) experimental; urgency=medium

  * New upstream release:
    - Fix importing GSS composite export names
    - Fix kadm5.acl wildcard matching when early lines have partial matches
    - Disable principal renames for LDAP; they do not work properly and are
      hard to fix
    - Fix LDAP ticket policies on big-endian LP64 systems
    - Fix memory leak in DB2 iteration
    - Prevent requires_preauth bypass (CVE-2015-2694), Closes: #783557
  * Add python to build-depends-indep, since we call it manually during
    the documentation build, Closes: #746395

 -- Benjamin Kaduk <kaduk@mit.edu>  Thu, 14 May 2015 13:38:58 -0400

krb5 (1.13.1+dfsg-1) experimental; urgency=low

  * New upstream release:
    - Make the KDC default to listening on TCP (as well as UDP)
    - Bump DAL major version for krb5_db_iterate() API change; KDB modules
      will need to be rebuilt
    - Let ksu use any keytab entry to verify the obtained TGT
    - Improve kadm5_randkey_principal interop with Solaris KDCs
    - Export symbols for some public gss interfaces
    - Allow the logger to work with redirected stderr
    - Remove length limit on PKINIT PKCS#12 prompts

 -- Benjamin Kaduk <kaduk@mit.edu>  Mon, 16 Mar 2015 14:23:06 -0400

krb5 (1.12.1+dfsg-20) unstable; urgency=high

  * Import upstream patch for CVE-2015-2694, Closes: #783557
  * Bump Standards-Version to 3.9.6 (no changes needed)

 -- Benjamin Kaduk <kaduk@mit.edu>  Wed, 13 May 2015 14:40:36 -0400

krb5 (1.13~alpha1+dfsg-1) experimental; urgency=low

  [ Jelmer Vernooij ]
  * Reintroduce changes to move krb5-config into krb5-multidev:


=== debian/control ===
--- 
+++ 
@@ -6,9 +6,10 @@
  libkeyutils-dev [linux-any], libldap2-dev,
  libncurses5-dev, libssl-dev,  ss-dev, 
  libverto-dev (>= 0.2.4), pkg-config, dh-systemd
-build-depends-indep: python-cheetah, python-lxml, python-sphinx, doxygen-latex
-Standards-Version: 3.9.5
-Maintainer: Sam Hartman <hartmans@debian.org>
+build-depends-indep: python, python-cheetah, python-lxml, python-sphinx, doxygen-latex
+Standards-Version: 3.9.6
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sam Hartman <hartmans@debian.org>
 Uploaders: Russ Allbery <rra@debian.org>, Benjamin Kaduk <kaduk@mit.edu>
 Homepage: http://web.mit.edu/kerberos/
 VCS-Git: git://git.debian.org/git/pkg-k5-afs/debian-krb5-2013.git
@@ -37,7 +38,8 @@
 Priority: optional
 Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (= ${binary:Version}),
  libkadm5srv-mit9,
- krb5-config, krb5-user, lsb-base (>= 3.0-6), libverto-libev1 | libverto-libevent1
+ krb5-config, krb5-user, lsb-base (>= 3.0-6), libverto-libev1 | libverto-libevent1,
+ libkdb5-8 (>= 1.13.1+dfsg-1)
 Suggests: openbsd-inetd | inet-superserver, krb5-admin-server,
  krb5-kdc-ldap (= ${binary:Version})
 Description: MIT Kerberos key server (KDC)
@@ -176,7 +178,8 @@
 
 Package: krb5-otp
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libkrad0 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libkrad0 (= ${binary:Version}),
+ libkrb5-3 (>= 1.12~alpha1+dfsg-1~)
 Priority: extra
 Multi-Arch: same
 Description: OTP plugin for MIT Kerberos
@@ -191,6 +194,24 @@
  (RFC 6560), which allows Kerberos tickets to be obtained using
  One-Time Password authentication.  This plugin is for use on the KDC; the
  client support is built in to libkrb5.
+
+Package: krb5-k5tls
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}, libkrb5-3 (>= 1.13~alpha1+dfsg~)
+Priority: extra
+Multi-Arch: same
+Description: TLS plugin for MIT Kerberos
+ Kerberos is a system for authenticating users and services on a network.
+ Kerberos is a trusted third-party service.  That means that there is a
+ third party (the Kerberos server) that is trusted by all the entities on
+ the network (users and services, usually called "principals").
+ .
+ This is the MIT reference implementation of Kerberos V5.
+ .
+ This package contains a plugin for the TLS functionality used by optional
+ functionality in MIT Kerberos.  The only current consumer is client support
+ for the MS-KKDCP protocol, which tunnels Kerberos protocol traffic through
+ an HTTPS proxy.
 
 Package: krb5-doc
 Architecture: all
@@ -259,24 +280,3 @@
 Suggests: krb5-doc, krb5-user
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Description: MIT Kerberos runtime libraries - GSS enabled ONCRPC
- Kerberos is a system for authenticating users and services on a network.
- Kerberos is a trusted third-party service.  That means that there is a
- third party (the Kerberos server) that is trusted by all the entities on
- the network (users and services, usually called "principals").
- .
- This is the MIT reference implementation of Kerberos V5.
- .
- This package contains an RPC library used by the Kerberos administrative
- programs and potentially other applications.
-
-Package: libkadm5srv-mit9
-Section: libs
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Suggests: krb5-doc, krb5-user
-Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
-Description: MIT Kerberos runtime libraries - KDC and Admin Server
- Kerberos is a system for authenticating users and services on a network.
- Kerberos is a trusted third-party service.  That means that there is a

=== debian/rules ===
#!/usr/bin/make -f
# Based on sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

SHELL=/bin/bash
export SHELL

# Tell Autoconf the correct system types.  Needed for cross builds.
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
    SYSTEM = --build $(DEB_HOST_GNU_TYPE)
    CACHE  =
else
    SYSTEM = --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
    CACHE  = --cache-file=$(DEB_HOST_GNU_TYPE).cache
endif

export DEB_HOST_MULTIARCH

CCOPTS=-g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    CCOPTS +=-O0
else
    CCOPTS +=-O2
endif

ifneq (,$(filter i486-linux-gnu x86_64-linux-gnu,$(DEB_HOST_GNU_TYPE)))
    CCOPTS +=-D_FORTIFY_SOURCE=2 -fstack-protector
    endif
FLAGS=$(shell if res=`dpkg-buildflags --export=configure `; then echo $$res; else echo   CFLAGS="'$(CCOPTS)'"; fi)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# The flags to pass to dh_install specifying the upstream files to exclude.
# We use --fail-missing to be sure we catch any new upstream files, so be
# sure to update this list if upstream adds any more files we don't want.
EXCLUDE = -Xtmac.doc -Xexamples/krb5 -Xgnats/mit -Xkrb5-send-pr \
	-Xsserver -Xsim_server -Xuuserver \
	-Xsclient -Xsim_client -Xuuclient

LIB_PACKAGES = libkrb5-3 libgssapi-krb5-2 libkadm5clnt-mit9 libkadm5srv-mit9 libkdb5-8 libgssrpc4  \
	libkrb5support0  libk5crypto3 libkrad0

# We touch each configure and Autoconf-related file so that we do not attempt
# to use Autoconf.  The cache is used by the Embdebian project for cross
# compiles.
configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir -p build
	find src -name configure -print | xargs touch
	find src \( -name \*hin -o -name \*.h.in -o -name \*.stmp \) -print \
		| xargs touch
	[ ! -f $(DEB_HOST_GNU_TYPE).cache ] \
		|| cp $(DEB_HOST_GNU_TYPE).cache build/
	cd build && $(FLAGS) ../src/configure  \
		--prefix=/usr --localstatedir=/etc --mandir=/usr/share/man \
		--with-system-et --with-system-ss --disable-rpath  \
		--enable-shared --with-ldap --without-tcl \
	--with-system-verto \
		--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--sysconfdir=/etc \
		$(SYSTEM) $(CACHE)
	touch configure-stamp

# Build the documentation in a separate directory, since otherwise we'll
# overwrite the info pages provided upstream and then debian/rules clean won't
# get back to a virgin copy of the package.
build: build-arch build-indep

build-arch: build-stamp

build-indep: build-indep-stamp

build-stamp: configure-stamp
	cd build && $(MAKE) $(NUMJOBS) all
	touch build-stamp

build-indep-stamp: build-stamp
	cd build/doc && make substhtml substpdf
	ln -sf /usr/share/javascript/jquery/jquery.js build/doc/html_subst/_static/jquery.js
	ln -sf /usr/share/javascript/underscore/underscore.js build/doc/html_subst/_static/underscore.js
	ln -sf /usr/share/javascript/sphinxdoc/1.0/doctools.js build/doc/html_subst/_static/doctools.js
	ln -sf /usr/share/javascript/sphinxdoc/1.0/searchtools.js build/doc/html_subst/_static/searchtools.js
	touch build-indep-stamp

clean:
	dh_testdir
	-rm -rf build doc/tools/*.pyc doc/version.py
	dh_clean build-stamp configure-stamp build-indep-stamp

install: DH_OPTIONS=
install: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	set -e; for file in krb5-kdc.dirs krb5-multidev.dirs krb5-multidev.links \
	            krb5-multidev.install libkrb5-3.dirs libkrb5-dev.dirs; \
	do \
		sed -e"s,\$${DEB_HOST_MULTIARCH},${DEB_HOST_MULTIARCH},g" \
			debian/$${file}.in > debian/$$file; \
	done
	dh_installdirs

	cd build && $(MAKE) install DESTDIR=`pwd`/../debian/tmp
	install -d $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/krb5 $(CURDIR)/debian/tmp/etc/insserv/overrides
	install -m644 debian/krb5-kdc-ldap.insserv-override debian/tmp/etc/insserv/overrides/krb5-kdc
	install -m644 $(CURDIR)/debian/README.mech.d $(CURDIR)/debian/libgssapi-krb5-2/etc/gss/mech.d/README
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libkdb_ldap* \
	    $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/krb5/
	rm -f $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/krb5/libkdb_ldap*.so
	mv $(CURDIR)/debian/tmp/usr/bin/krb5-config \
	    $(CURDIR)/debian/tmp/usr/bin/krb5-config.mit
	mv $(CURDIR)/debian/tmp/usr/share/man/man1/krb5-config.1 \
	    $(CURDIR)/debian/tmp/usr/share/man/man1/krb5-config.mit.1

	install -m644 src/util/ac_check_krb5.m4 \
		debian/libkrb5-dev/usr/share/aclocal

	dh_install --fail-missing $(EXCLUDE)
	set -e ; find debian/krb5-multidev/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5 -type l -name \*.so -print |\
		while read linkname; do \
		ln -s -f ../`readlink $$linkname` \
		$$linkname; \
	done
		rm debian/krb5-multidev/usr/include/mit-krb5/krad.h debian/krb5-multidev/usr/lib/*/mit-krb5/libkrad.so
		for dir in include lib/$(DEB_HOST_MULTIARCH) lib/$(DEB_HOST_MULTIARCH)/pkgconfig; do \
		(cd debian/krb5-multidev/usr/$$dir/mit-krb5 && \
		find . -type d -print ) | (cd debian/libkrb5-dev/usr/$$dir && \
		xargs mkdir -p); \
		(cd debian/krb5-multidev/usr/$$dir/mit-krb5 && find . \( -type f -o -type l \) -print ) | \
		(cd debian/libkrb5-dev/usr/$$dir && xargs -I+ ln -s /usr/$$dir/mit-krb5/+ +) ; \
		done
	# however we will handle libkadm5{srv,clnt.so} in dh_link
# because they actually point to the current level not one level up
	rm -f debian/krb5-multidev/usr/lib/$(DEB_HOST_MULTIARCH)/mit-krb5/libkadm5{clnt,srv}.so


	docbook-to-man debian/krb5_newrealm.sgml \
		> debian/krb5-admin-server/usr/share/man/man8/krb5_newrealm.8
	install -o root -g root -m 755 debian/krb5_newrealm \
		debian/krb5-admin-server/usr/sbin
	install -o root -g root -m 644 debian/kdc.conf \
		debian/krb5-kdc/usr/share/krb5-kdc/kdc.conf.template
	ln -s /usr/share/krb5-kdc/kdc.conf.template \
		debian/krb5-kdc/usr/share/doc/krb5-kdc/examples/kdc.conf

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: DH_OPTIONS=-i
binary-indep: build-indep  install
	dh_testdir
	dh_testroot
	dh_installchangelogs  -Xdoc/CHANGES
	dh_installchangelogs -pkrb5-doc -k doc/CHANGES
	dh_installdocs
	dh_installinfo
	dh_link
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
# Pass -a to all debhelper commands in this target to reduce clutter.  Strip
# library packages  separately and save the debug information for the
# libkrb5-dbg package.  This method strips the libraries in those packages
# twice, but that should be harmless and all other ways of doing this seem
# uglier.
binary-arch: DH_OPTIONS=-a
binary-arch: build-arch install
	dh_testdir
	dh_testroot
	dh_installchangelogs  -Xdoc/CHANGES
	dh_installdocs
	dh_installdebconf
	DH_OPTIONS= dh_installinit -pkrb5-kdc --error-handler=init_error -- defaults 18 18 
		DH_OPTIONS= dh_installinit -pkrb5-admin-server -- defaults 18 18 
	dh_systemd_enable
	dh_lintian
	set -e ; for pkg in $(LIB_PACKAGES) ; do \
		DH_OPTIONS="" dh_strip -p$$pkg --dbg-package=libkrb5-dbg; \
		DH_OPTIONS="" dh_makeshlibs -p$$pkg -Xusr/lib/$(DEB_HOST_MULTIARCH)/krb5/plugins -- -c4 ; \
	done
	dh_strip
	dh_link
	dh_compress
	dh_fixperms
	chmod u+s debian/krb5-user/usr/bin/ksu
	chmod 700 debian/krb5-kdc/var/lib/krb5kdc
	chmod 700 debian/krb5-kdc/etc/krb5kdc
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean configure binary-indep binary-arch binary install
